//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   MemoOut->Lines->Clear();
   MemoXORed->Lines->Clear();

 int i, j;
 unsigned short context; /* The 16 bit register that holds the context or state */
 unsigned long scrambler; /* The 32 bit output of the circuit */
 unsigned char n[16]; /* The individual bits of context */
 unsigned char next[32]; /* The computed bits of scrambler */
          /* Parallelized versions of the scrambler are initialized to a value */
          /* derived from the initialization value of 0xFFFF defined in the */
          /* specification. This implementation is initialized to 0xF0F6. Other */
          /* parallel implementations have different initial values. The */
          /* important point is that the first Dword output of any implementation */
          /* needs to equal 0xC2D2768D. */
 context =  0xF0F6; //0xFFFF;
 for (i = 0; i < MemoIn->Lines->Count; ++i)
 {
     /* Split the register contents (the variable context) up into its */
     /* individual bits for easy handling. */
    for (j = 0; j < 16; ++j)
    {
     n[j] = (context >> j) & 0x01;
    }
    /* The following 16 assignments implement the matrix multiplication */
    /* performed by the box labeled *M1. */
    /* Notice that there are lots of shared terms in these assignments. */
    next[31] = n[12] ^ n[10] ^ n[7] ^ n[3] ^ n[1] ^ n[0];
    next[30] = n[15] ^ n[14] ^ n[12] ^ n[11] ^ n[9] ^ n[6] ^ n[3] ^ n[2] ^ n[0];
    next[29] = n[15] ^ n[13] ^ n[12] ^ n[11] ^ n[10] ^ n[8] ^ n[5] ^ n[3] ^ n[2] ^ n[1];
    next[28] = n[14] ^ n[12] ^ n[11] ^ n[10] ^ n[9] ^ n[7] ^ n[4] ^ n[2] ^ n[1] ^ n[0];
    next[27] = n[15] ^ n[14] ^ n[13] ^ n[12] ^ n[11] ^ n[10] ^ n[9] ^ n[8] ^ n[6] ^ n[1] ^ n[0];
    next[26] = n[15] ^ n[13] ^ n[11] ^ n[10] ^ n[9] ^ n[8] ^ n[7] ^ n[5] ^ n[3] ^ n[0];
    next[25] = n[15] ^ n[10] ^ n[9] ^ n[8] ^ n[7] ^ n[6] ^ n[4] ^ n[3] ^ n[2];
    next[24] = n[14] ^ n[9] ^ n[8] ^ n[7] ^ n[6] ^ n[5] ^ n[3] ^ n[2] ^ n[1];
    next[23] = n[13] ^ n[8] ^ n[7] ^ n[6] ^ n[5] ^ n[4] ^ n[2] ^ n[1] ^ n[0];
    next[22] = n[15] ^ n[14] ^ n[7] ^ n[6] ^ n[5] ^ n[4] ^ n[1] ^ n[0];
    next[21] = n[15] ^ n[13] ^ n[12] ^ n[6] ^ n[5] ^ n[4] ^ n[0];
    next[20] = n[15] ^ n[11] ^ n[5] ^ n[4];
    next[19] = n[14] ^ n[10] ^ n[4] ^ n[3];
    next[18] = n[13] ^ n[9] ^ n[3] ^ n[2];
    next[17] = n[12] ^ n[8] ^ n[2] ^ n[1];
    next[16] = n[11] ^ n[7] ^ n[1] ^ n[0];
    /* The following 16 assignments implement the matrix multiplication */
    /* performed by the box labeled *M2. */
    next[15] = n[15] ^ n[14] ^ n[12] ^ n[10] ^ n[6] ^ n[3] ^ n[0];
    next[14] = n[15] ^ n[13] ^ n[12] ^ n[11] ^ n[9] ^ n[5] ^ n[3] ^ n[2];
    next[13] = n[14] ^ n[12] ^ n[11] ^ n[10] ^ n[8] ^ n[4] ^ n[2] ^ n[1];
    next[12] = n[13] ^ n[11] ^ n[10] ^ n[9] ^ n[7] ^ n[3] ^ n[1] ^ n[0];
    next[11] = n[15] ^ n[14] ^ n[10] ^ n[9] ^ n[8] ^ n[6] ^ n[3] ^ n[2] ^ n[0];
    next[10] = n[15] ^ n[13] ^ n[12] ^ n[9] ^ n[8] ^ n[7] ^ n[5] ^ n[3] ^ n[2] ^ n[1];
    next[9] = n[14] ^ n[12] ^ n[11] ^ n[8] ^ n[7] ^ n[6] ^ n[4] ^ n[2] ^ n[1] ^ n[0];
    next[8] = n[15] ^ n[14] ^ n[13] ^ n[12] ^ n[11] ^ n[10] ^ n[7] ^ n[6] ^ n[5] ^ n[1] ^ n[0];
    next[7] = n[15] ^ n[13] ^ n[11] ^ n[10] ^ n[9] ^ n[6] ^ n[5] ^ n[4] ^ n[3] ^ n[0];
    next[6] = n[15] ^ n[10] ^ n[9] ^ n[8] ^ n[5] ^ n[4] ^ n[2];
    next[5] = n[14] ^ n[9] ^ n[8] ^ n[7] ^ n[4] ^ n[3] ^ n[1];
    next[4] = n[13] ^ n[8] ^ n[7] ^ n[6] ^ n[3] ^ n[2] ^ n[0];
    next[3] = n[15] ^ n[14] ^ n[7] ^ n[6] ^ n[5] ^ n[3] ^ n[2] ^ n[1];
    next[2] = n[14] ^ n[13] ^ n[6] ^ n[5] ^ n[4] ^ n[2] ^ n[1] ^ n[0];
    next[1] = n[15] ^ n[14] ^ n[13] ^ n[5] ^ n[4] ^ n[1] ^ n[0];
    next[0] = n[15] ^ n[13] ^ n[4] ^ n[0];
    /* The 32 bits of the output have been generated in the "next" array. */
    /* Reassemble the bits into a 32 bit Dword. */
    scrambler = 0;
    for (j = 31; j >= 0; --j)
    {
     scrambler = scrambler << 1;
     scrambler |= next[j];
    }
    /* The upper half of the scrambler output is stored backed into the */
    /* register as the saved context for the next cycle. */
    context = scrambler >> 16;

    MemoOut->Lines->Add(IntToHex((__int64)scrambler, 8));
 }

 for(int i=0;i<MemoIn->Lines->Count;++i)
 {
  if(MemoIn->Lines->Strings[i] == "") MemoIn->Lines->Delete(i);
 }

 Label4->Caption = MemoIn->Lines->Count;
 
  for(int i=0;i<MemoIn->Lines->Count;++i)
 {
  int p = StrToInt("0x"+MemoIn->Lines->Strings[i]) ^ StrToInt("0x"+MemoOut->Lines->Strings[i]);
  AnsiString z = IntToHex((__int64)(p), 8);
  MemoXORed->Lines->Add((z.Length()>8)?z.SubString(9,8):z);
 }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  int data_count, i;
  unsigned __int32 data_in, crc;
  int data_ins;
  unsigned char cb[32], new_bit[32];
  crc = 0x52325032;
  data_count = 0;

  for(int i=0;i<MemoIn->Lines->Count;++i)
  {
   if(MemoIn->Lines->Strings[i] == "") MemoIn->Lines->Delete(i);
  }

  for ( int j=0; j<MemoIn->Lines->Count; j++ ) {
    AnsiString Str = MemoIn->Lines->Strings[j];
    if (TryStrToInt("0x"+Str,data_ins)) {
       data_in = data_ins;
       data_count++;
		/* Add the data_in value to the current value of the CRC held in the */
		/* "register". The addition is performed modulo two (XOR). */
        crc ^= data_in;
		/* Expand the value of the CRC held in the register to 32 individual */
		/* bits for easy manipulation. */
		for (i = 0; i < 32; i++) {
			cb[i] = (crc >> i) & 0x01;
		}
		/* The following 32 assignments perform the function of the box */
		/* labeled "*" in the block diagram above. The new_bit array is a */
		/* temporary holding place for the new CRC value being calculated. */
		/* Note that there are lots of shared terms in the assignments below. */
		new_bit[31]=cb[31]^cb[30]^cb[29]^cb[28]^cb[27]^cb[25]^cb[24]^cb[23]^cb[15]^cb[11]^cb[9] ^cb[8] ^cb[5];
		new_bit[30]=cb[30]^cb[29]^cb[28]^cb[27]^cb[26]^cb[24]^cb[23]^cb[22]^cb[14]^cb[10]^cb[8] ^cb[7] ^cb[4];
		new_bit[29]=cb[31]^cb[29]^cb[28]^cb[27]^cb[26]^cb[25]^cb[23]^cb[22]^cb[21]^cb[13]^cb[9] ^cb[7] ^cb[6]^cb[3];
		new_bit[28]=cb[30]^cb[28]^cb[27]^cb[26]^cb[25]^cb[24]^cb[22]^cb[21]^cb[20]^cb[12]^cb[8] ^cb[6] ^cb[5]^cb[2];
		new_bit[27]=cb[29]^cb[27]^cb[26]^cb[25]^cb[24]^cb[23]^cb[21]^cb[20]^cb[19]^cb[11]^cb[7] ^cb[5] ^cb[4]^cb[1];
		new_bit[26]=cb[31]^cb[28]^cb[26]^cb[25]^cb[24]^cb[23]^cb[22]^cb[20]^cb[19]^cb[18]^cb[10]^cb[6] ^cb[4]^cb[3]^cb[0];
		new_bit[25]=cb[31]^cb[29]^cb[28]^cb[22]^cb[21]^cb[19]^cb[18]^cb[17]^cb[15]^cb[11]^cb[8] ^cb[3] ^cb[2];
		new_bit[24]=cb[30]^cb[28]^cb[27]^cb[21]^cb[20]^cb[18]^cb[17]^cb[16]^cb[14]^cb[10]^cb[7] ^cb[2] ^cb[1];
		new_bit[23]=cb[31]^cb[29]^cb[27]^cb[26]^cb[20]^cb[19]^cb[17]^cb[16]^cb[15]^cb[13]^cb[9] ^cb[6] ^cb[1]^cb[0];
		new_bit[22]=cb[31]^cb[29]^cb[27]^cb[26]^cb[24]^cb[23]^cb[19]^cb[18]^cb[16]^cb[14]^cb[12]^cb[11]^cb[9]^cb[0];
		new_bit[21]=cb[31]^cb[29]^cb[27]^cb[26]^cb[24]^cb[22]^cb[18]^cb[17]^cb[13]^cb[10]^cb[9] ^cb[5];
		new_bit[20]=cb[30]^cb[28]^cb[26]^cb[25]^cb[23]^cb[21]^cb[17]^cb[16]^cb[12]^cb[9] ^cb[8] ^cb[4];
		new_bit[19]=cb[29]^cb[27]^cb[25]^cb[24]^cb[22]^cb[20]^cb[16]^cb[15]^cb[11]^cb[8] ^cb[7] ^cb[3];
		new_bit[18]=cb[31]^cb[28]^cb[26]^cb[24]^cb[23]^cb[21]^cb[19]^cb[15]^cb[14]^cb[10]^cb[7] ^cb[6] ^cb[2];
		new_bit[17]=cb[31]^cb[30]^cb[27]^cb[25]^cb[23]^cb[22]^cb[20]^cb[18]^cb[14]^cb[13]^cb[9] ^cb[6] ^cb[5]^cb[1];
		new_bit[16]=cb[30]^cb[29]^cb[26]^cb[24]^cb[22]^cb[21]^cb[19]^cb[17]^cb[13]^cb[12]^cb[8] ^cb[5] ^cb[4]^cb[0];
		new_bit[15]=cb[30]^cb[27]^cb[24]^cb[21]^cb[20]^cb[18]^cb[16]^cb[15]^cb[12]^cb[9] ^cb[8] ^cb[7] ^cb[5]^cb[4]^cb[3];
		new_bit[14]=cb[29]^cb[26]^cb[23]^cb[20]^cb[19]^cb[17]^cb[15]^cb[14]^cb[11]^cb[8] ^cb[7] ^cb[6] ^cb[4]^cb[3]^cb[2];
		new_bit[13]=cb[31]^cb[28]^cb[25]^cb[22]^cb[19]^cb[18]^cb[16]^cb[14]^cb[13]^cb[10]^cb[7] ^cb[6] ^cb[5]^cb[3]^cb[2]^cb[1];
		new_bit[12]=cb[31]^cb[30]^cb[27]^cb[24]^cb[21]^cb[18]^cb[17]^cb[15]^cb[13]^cb[12]^cb[9] ^cb[6] ^cb[5]^cb[4]^cb[2]^cb[1]^cb[0];
		new_bit[11]=cb[31]^cb[28]^cb[27]^cb[26]^cb[25]^cb[24]^cb[20]^cb[17]^cb[16]^cb[15]^cb[14]^cb[12]^cb[9]^cb[4]^cb[3]^cb[1]^cb[0];
		new_bit[10]=cb[31]^cb[29]^cb[28]^cb[26]^cb[19]^cb[16]^cb[14]^cb[13]^cb[9] ^cb[5] ^cb[3] ^cb[2] ^cb[0];
		new_bit[9] =cb[29]^cb[24]^cb[23]^cb[18]^cb[13]^cb[12]^cb[11]^cb[9] ^cb[5] ^cb[4] ^cb[2] ^cb[1];
		new_bit[8] =cb[31]^cb[28]^cb[23]^cb[22]^cb[17]^cb[12]^cb[11]^cb[10]^cb[8] ^cb[4] ^cb[3] ^cb[1] ^cb[0];
		new_bit[7] =cb[29]^cb[28]^cb[25]^cb[24]^cb[23]^cb[22]^cb[21]^cb[16]^cb[15]^cb[10]^cb[8] ^cb[7] ^cb[5]^cb[3]^cb[2]^cb[0];
		new_bit[6] =cb[30]^cb[29]^cb[25]^cb[22]^cb[21]^cb[20]^cb[14]^cb[11]^cb[8] ^cb[7] ^cb[6] ^cb[5] ^cb[4]^cb[2]^cb[1];
		new_bit[5] =cb[29]^cb[28]^cb[24]^cb[21]^cb[20]^cb[19]^cb[13]^cb[10]^cb[7] ^cb[6] ^cb[5] ^cb[4] ^cb[3]^cb[1]^cb[0];
		new_bit[4] =cb[31]^cb[30]^cb[29]^cb[25]^cb[24]^cb[20]^cb[19]^cb[18]^cb[15]^cb[12]^cb[11]^cb[8] ^cb[6]^cb[4]^cb[3]^cb[2]^cb[0];
		new_bit[3] =cb[31]^cb[27]^cb[25]^cb[19]^cb[18]^cb[17]^cb[15]^cb[14]^cb[10]^cb[9] ^cb[8] ^cb[7] ^cb[3]^cb[2]^cb[1];
		new_bit[2] =cb[31]^cb[30]^cb[26]^cb[24]^cb[18]^cb[17]^cb[16]^cb[14]^cb[13]^cb[9] ^cb[8] ^cb[7] ^cb[6]^cb[2]^cb[1]^cb[0];
		new_bit[1] =cb[28]^cb[27]^cb[24]^cb[17]^cb[16]^cb[13]^cb[12]^cb[11]^cb[9] ^cb[7] ^cb[6] ^cb[1] ^cb[0];
		new_bit[0] =cb[31]^cb[30]^cb[29]^cb[28]^cb[26]^cb[25]^cb[24]^cb[16]^cb[12]^cb[10]^cb[9] ^cb[6] ^cb[0];
		/* The new CRC value has been calculated as individual bits in the */
		/* new_bit array. Re-assembled it into a 32 bit value and "clock" it */
		/* into the "register". */
		crc = 0;
		for (i = 31; i >= 0; --i) { 
			crc = crc << 1;
			crc |= new_bit[i];
		}

    } else {
      if ((Str.Length()==0)||(Str[1]!='#')) MemoIn->Lines->Strings[j] = "# - "+Str;
    }
  }

  MemoIn->Lines->Add(IntToHex((__int64)crc,8));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   MemoIn->Clear();

   MemoIn->Lines->Add("00000046");

   if(LabeledEdit3->Text=="")
   {
      for(unsigned int i=LabeledEdit1->Text.ToIntDef(0);i<=LabeledEdit2->Text.ToIntDef(2047);i++)
      {
         MemoIn->Lines->Add(IntToHex((__int64)i,8));
      }
   }else
   {
      if(LabeledEdit1->Text=="")
      {
         for(unsigned int i=LabeledEdit2->Text.ToIntDef(2047)-LabeledEdit3->Text.ToIntDef(2048)+1;i<=LabeledEdit2->Text.ToIntDef(2047);i++)
         {
            MemoIn->Lines->Add(IntToHex((__int64)i,8));
         }
      }else
      {
         for(unsigned int i=LabeledEdit1->Text.ToIntDef(0);i<=LabeledEdit1->Text.ToIntDef(0)+LabeledEdit3->Text.ToIntDef(2048)-1;i++)
         {
            MemoIn->Lines->Add(IntToHex((__int64)i,8));
         }
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   MemoIn->Clear();
   MemoXORed->Clear();
   MemoOut->Clear();
}
//---------------------------------------------------------------------------

